import graph
import sys
import collections

def build_sp(lf,rs,outfile,verbose=False):
    global G,GB

    if verbose:
        print '[buildgraph] using files'
        for x in lf:
            print x
        
    FQ = graph.FastqFile(lf)
    G = graph.Graph()
    GB = graph.GraphBuilder(G, rs)
    if verbose:
        print "processing file"; sys.stdout.flush()
    GB.processFastqFile(FQ)
    
    opt = graph.ClipTipOptions()
    opt.maxLength = 42

    G.clipTips(opt)

    if verbose:
        print 'saving file to '+outfile; sys.stdout.flush()

    GB.saveBinaryFile(outfile)

    return G,GB


def load_binfile(f):
    G = graph.Graph()
    GB = graph.GraphBuilder(G,100)
    GB.loadBinaryFile(f)
    return G

def revind(ind):
    d = collections.defaultdict(list)
    for i,g in ind.items():
        d[g].append(i)
    for g in d:
        d[g].sort()
    return dict(d)

def save_outv(rev, outv,name):
    f = open(name,'w')
    for j,(g,l) in enumerate(rev.iteritems()):
        if (j+1) % 1000 == 0:
            print j+1
            
        f.write('>'+g+'\n')
        gl = 0
        for i in l:
            tp = outv[i]
            xl = [(x.km,x.refpos()+gl) for x in tp]
            for km,p in xl:
                f.write("%s\t%d\n"%(str(km),p))
    f.close()


def read_outv(s):
    f = open('genes/%s_kmers.txt'%(s,))
    genes = {}
    gene = None
    for line in f:
        if line[0] == '>':
            gene = line.strip()[1:]
            genes[gene] = []
        elif gene != None:
            l = line.split()
            genes[gene].append((l[0],int(l[1])))
    f.close()
    return genes

def iter_outv(name):
    f = open(name)
    gene = None
    ls = None
    for line in f:
        if line[0] == '>':
            if gene != None:
                yield gene,ls
            gene = line.strip()[1:]
            ls = []
        else:
            l = line.split()
            ls.append((l[0],int(l[1])))
    f.close()
    raise StopIteration

def pick_out(iov,gset):
    res = {}
    for g,l in iov:
        if g in gset:
            res[g] = l

    return res

def jump_to(iov,gt):
    g,l = iov.next()
    while g != gt:
        g,l = iov.next()

    return iov,(g,l)
