import tempfile
import subprocess
import re

def raw_align(ref,seq):
    f = tempfile.NamedTemporaryFile(mode='w')
    f.write('>ref\n%s\n'%(ref))
    for i,s in enumerate(seq):
        f.write('>seq%d\n%s\n'%(i,s))
    
    f.seek(0)
    outp =  subprocess.Popen(['fsa %s'%(f.name,)],shell=True,stdout=subprocess.PIPE,stderr=open('/dev/null','w')).communicate()[0]
    

    f.close()
    return outp

def align(ref,seqs):
    out = raw_align(ref,seqs)

    l  = re.split('\>seq(\d)+',out)


    la = l[0].split('\n')
    sa = ''.join(la[1:-1])

    sbs = []
    for lx in l[1:]:
        lb = lx.split('\n')
        sb = ''.join(lb[:-1])
        if len(sb) > 0:
            sbs.append(sb)
    return sa,sbs

def align_contig(ref,c):
    sa,sb = align(ref,c)
    gapb = [i for i in xrange(len(sb)) if sb[i] != '-']
    r1,r2 = min(gapb),max(gapb)+1

    return(sa[r1:r2],sb[r1:r2])
    
                    




    
