import collections

from contig_graph import *

def get_all_contigs(G,kv,cov,verbose=False):
    contigs = []
    done = set()
    for x in kv:
        if str(x) in done:
            continue
        if verbose:
            print "finding contig for",str(x),
            sys.stdout.flush()
        c = super_contig(G,x,cov,verbose)
        if verbose:
            print "found",len(c)
        for y in c:
            done.add(str(y))
        contigs.append(c)
    return contigs


            

def connected_component(G,kv,cov,max_count = None):
    global stopFlag
    try:
        stopFlag
    except NameError:
        stopFlag = False
        
    d = collections.deque([x for x in kv])
    done = set()

    while len(d) > 0 and (max_count==None or len(done) <= max_count):
        if stopFlag:
            break
        km = d.popleft()
        for x in cov_filter(G,cov,G.fwBegin(km)):
            if str(x) not in done:
                d.append(x)
        for x in cov_filter(G,cov,G.bwBegin(km)):
            if str(x) not in done:
                d.append(x)

        done.add(str(km))
        

    return [graph.Kmer(x) for x in done]

def super_contig(G,km,cov,verbose=False):
    
    if verbose: print "starting from ",str(km); sys.stdout.flush()
    l = collections.deque([km])
    if not cov[0] <= G.coverage(km) <= cov[1]:
        return list(l)
    last = km
    first = km
    prev, next = None,None
    j = 0
    if verbose:
        print "going forward "
        sys.stdout.flush()

    while True:
        j += 1
        cand = list(cov_filter(G,cov,G.bwBegin(first)))
        if len(cand)==1:
            prev = cand[0]
        else:
            break

        cand = list(cov_filter(G,cov,G.fwBegin(prev)))
        if len(cand)==1:
            if prev != l[-1]:
                l.appendleft(prev)
            else:
                break
            first = prev
        else:
            break



        if verbose and j % 1000 == 0:
            print j,"rounds"
            sys.stdout.flush()


    if verbose:
        print "going backwards "
        sys.stdout.flush()
    j = 0
    while True:
        cand = list(cov_filter(G,cov,G.fwBegin(last)))
        if len(cand)==1:
            next = cand[0]
        else:
            break

        cand = list(cov_filter(G,cov,G.bwBegin(next)))
        if len(cand)==1:
            if next != l[0]:
                l.append(next)
            else:
                break 
            last = next
        else:
            break

    return list(l)
