import collections,itertools
import graph

def flatten(l):
    return list(itertools.chain.from_iterable(l))

def print_contigs(G,contigs):
    for i,c in enumerate(contigs):
        print ">seq_%d_%d_%d\n%s"%(i,len(c),sum(G.coverage(x) for x in c)/len(c), contig_to_string(c))

def fake_G(G,cov_factor):
    G.coverage = lambda x: cov_factor * graph.Graph.coverage(G,x)



def hist(l):
    d = collections.defaultdict(int)
    for x in l:
        d[x] += 1
    return dict(d)


def kmers_for_string(G,s,k):
    opt = graph.SimilarSequenceOptions()
    opt.k = k
    kv = graph.KmerVector()
    G.pickSimilar(s,kv,opt)
    return kv



def safe_kmer(x):
    if x != None and len(x) == graph.cvar.Kmer_k and all(t in 'ACGT' for t in x):
        return graph.Kmer(x)
    else:
        return None

def path_seq(p):
    return str(p[0])+''.join(str(x)[38:] for x in p[1:])

def path_cov(p,s):
    return [G[s].coverage(x) for x in p]

def load_fasta(fn):
    d = collections.defaultdict(list)
    f = open(fn)
    g = None
    for line in f:
        if line[0] == '>':
            g = line.strip()[1:]
        else:
            d[g].append(line.strip())
    dd = {}
    for g in d:
        dd[g] = ''.join(d[g])
    return dd
