def get_gene_file():
    f = open('/home/marioni/DownstreamAnalysisPJ/GeneInfo/refFlat.txt')    
    genes = collections.defaultdict(list)
    chrs = set(['chr'+str(i) for i in xrange(23)] + ['chrX','chrY','chrM'])
    for line in f:
        gene,nm,chr,strand,b,e,gb,ge,num_ex, ex_beg,ex_end = line.split()
        if chr in chrs:
            genes[gene].append([nm,chr,strand])
    return genes

class tr_info:
    def __init__(self):
        self.chr = None
        self.strand = None
        self.length = 0
        self.exons = []

    def __str__(self):
        return 'chr: %s, strand: %s, length: %s\nexons: %s'%(self.chr,self.strand,self.length,self.exons)

def exon_maps(s):
    exon_map = collections.defaultdict(tr_info)
    #tr_names = get_tr_names()
    done = set()
    #for tr in tr_names:
    #   exon_map[tr] = tr_info()
    
    
    exon_file = get_new_exon_file(s)
    print "using file",exon_file
    f = open(exon_file)
    matcher = re.compile('(.*):(\d*)-(\d*)(.)')
    for line in f:
        if line.startswith('INFO'):
            continue
        if line.startswith('>'):
            break
        l = line.split()
        if len(l) != 4 and len(l) != 5:
            print l
            print len(l)
            print line
            break

        
        tr = nm_rep(l[0])

        exon_len = int(l[1])
        exon_map[tr].length += exon_len
        if len(l) == 4:
            exon_map[tr].exons.append((None,exon_len))
        else:
            m = matcher.match(l[4])
            
            if exon_map[tr].chr == None:
                exon_map[tr].chr = m.group(1)
            if exon_map[tr].strand == None:
                exon_map[tr].strand = m.group(4)

            if exon_map[tr].strand == '+':
                exon_map[tr].exons.append((int(m.group(2)),exon_len))
            elif exon_map[tr].strand == '-':
                exon_map[tr].exons.append((int(m.group(3)),exon_len))
            
            
        #l2 = l[0].split
        
    f.close()    
    return dict(exon_map)


def get_nm_fasta(f = 'refseq/genes.fasta', s = None):
    nm = True
    if f==None:
        f = open("/home/pmelsted/primSeq/penultimateResults/TransRef/All%sTrans.fasta"%(s,))
    else:
        nm = False
        if isinstance(f,str):
            f = open(f)
    nms = dict()
    for line in f:
        if line[0] == '>':
            if nm:
                name = nm_rep(line.strip()[1:])
            else:
                name = line.strip()[1:]
            nms[name] = []
        else:
            nms[name].append(line.strip())

    f.close()
    genes = dict()
    for name in nms:
        genes[name] = ''.join(nms[name])

    return genes
    
def all_genes(genes,ex, nm_fasta):
    gseq = dict()
    for g in genes:
        r = get_seq_for_gene(g,genes,ex,nm_fasta)
        if len(r) > 0:
            gseq[g] = r

    return gseq

def get_seq_for_gene(gname,genes,ex, nm_fasta):
    nms = []
    strand = None
    strands = set()
    for x in genes[gname]:
        nm = x[0] 
        if nm in ex and nm in nm_fasta:
            nms.append(nm)
            strands.add(ex[nm].strand)

    dir = 1
    if len(strands) > 1:
        print "too many strands"
        return ''
    elif len(strands)==1:
        strand = iter(strands).next()
        if strand=='-':
            dir = -1
    else:
        return ''
    
    pos = set()
    for nm in nms:
        t = ex[nm]
        tot = 0
        for start,length in t.exons:
            if start != None:
                pos.add((start,start+dir*(length-1), nm_fasta[nm][tot:(tot+length)]))
            tot += length

    pos = list(pos)
    pos.sort(reverse=(strand=='-'))

    seq = []
    printedoverlap = False
    for i,(start,stop,s) in enumerate(pos):
        if i +1 < len(pos):
            overlap = (stop < pos[i+1][0])
            new_part = dir*(pos[i+1][0]-start)

            if not overlap:
                seq.append(s)
            else:
                if not printedoverlap:
                    #print gname
                    printedoverlap = True
                #print "first",(start,stop)," second", (pos[i+1][0],pos[i+1][1])
                seq.append(s[:new_part])
        else:
            seq.append(s)

    ret = ''.join(seq).translate(None,'-')

    if len(nms) == 1:
        if not (ret == nm_fasta[nms[0]].translate(None,'-')):
            print 'Error working with'
            print nms[0]
            print ret
            print ''+nm_fasta[nms[0]].translate(None,'-')
        pass
    return ret

def get_gseq():
    global ex,nm_fasta,genes,gseq
    genes = get_gene_file()
    ex = exon_maps('Human')
    nm_fasta = get_nm_fasta(s='Human',f=None)
    gseq = all_genes(genes,ex,nm_fasta)
